;=====i2c lcd test for Ericsson t39 / Version 1.0======02/10/03==
;	iic lcd driver: custom 
;	ra0,ra1,ra2,ra3     sdata, sclock, _reset,lcd power control
;	rb0 to rb7	led outputs
;	internal clock
;	standard crystal 4.000 MHz XT - 1us pe instructiune
;	Program realizat de Ing. Bergthaller Iulian-Alexandru 
;------------------------------------------------------------
;------------------------------------------------------------
;	configure programmer
	list	p=16f628;f=inhx8m
	__CONFIG	_PWRTE_ON  & _WDT_OFF & _XT_OSC & _BODEN_OFF & _LVP_OFF & _CP_OFF & _MCLRE_ON
;------------------------------------------------------------
;------------------------------------------------------------
 	org	0x00
	goto	init
	org	0x04
;------------------------------------------------------------
	#INCLUDE P16F628.INC
;------------------------------------------------------------

;      cpu init

	cblock 0x20	; Beginn General Purpose-Register

	count1	
	count2	
	count3	
	count4	
	count5
	transo	
	
	endc
;------------------------------------------------------------
#DEFINE power	PORTA,2
#DEFINE rset	PORTB,2
#DEFINE sclk	PORTB,1
#DEFINE sdta	PORTB,0
;------------------------------------------------------------
;------------------------------------------------------------
	org	0x00
;	goto	init
	org	0x04
;------------------------------------------------------------
init	bsf	STATUS,RP0  ;switch to bank 1
	clrf	TRISA
	clrf	TRISB
	bcf	STATUS,RP0  ;switch back to bank 0
	clrf	PORTA
	clrf	PORTB
;***************************************************
start	bcf	rset
	call	haltb	; rset time - min. 100ns
	bsf	power
	call	haltb
	bsf	rset	; reset finished
	call	haltb
;***************************************************
;* Lcd init commands                               *
;***************************************************
nou	call	iict	; i2c start
	movlw	0x76	; device write address 
	call	act	; i2c send subroutine
	movlw	0x10	; 
	call	act	; i2c send subroutine
	call	iicp	; i2c stop
	call	haltb
;***************************************************
	call	iict	; i2c start
	movlw	0x76	; 
	call	act
	movlw	0x30	; 
	call	act
	movlw	0x21	; 
	call	act
	movlw	0x35	; 
	call	act
	movlw	0x80	; 
	call	act
	movlw	0xAC	; 
	call	act
	movlw	0xD0	; 
	call	act
	movlw	0xFF	; 
	call	act
	movlw	0x08	; page
	call	act
	movlw	0x36	; lcd termo compensation
	call	act
	movlw	0x09	; page 
	call	act	; ok
	movlw	0x00	; 
	call	act
	movlw	0x0A	; 
	call	act
	movlw	0x0E	; 
	call	act
	movlw	0x0B	; 
	call	act
	movlw	0x06	; 
	call	act
	movlw	0x0C	; 
	call	act
	movlw	0x00	; 
	call	act
	movlw	0x0D	; 
	call	act
	movlw	0x00	; 
	call	act
	movlw	0x0F	; 
	call	act
	movlw	0x00	; 
	call	act
	call	iicp	; i2c stop
	call	pause
;***************************************************
	call	iict	; i2c start
	movlw	0x76	; device write address 
	call	act	; i2c send subroutine
	movlw	0x02	; 	
	call	act	; i2c send subroutine
	call	iicp	; i2c stop
	call	pause
;***************************************************
	call	iict	; i2c start
	movlw	0x76	; 
	call	act
	movlw	0x42	; 
	call	act
	movlw	0x00	; 
	call	act
	movlw	0x64	; 
	call	act
	movlw	0x0D
	movwf	count5
cls1	movlw	0x65
	movwf	count4
cls2	movlw	0x00	; 
	call	act
	decfsz	count4,F	
	goto	cls2
	decfsz	count5,F	
	goto	cls1
	call	iicp	; i2c stop
	call	pause
;***************************************************
	call	iict	; i2c start
	movlw	0x76	; 
	call	act
	movlw	0x42	; 
	call	act
	movlw	0x00	; 
	call	act
	movlw	0x64	; 
	call	act
	movlw	0xFF	; 
	call	act
	movlw	0x2F	; 
	call	act
	movlw	0x11	; 
	call	act
	movlw	0x22	; 
	call	act
	movlw	0x33	;
	call	act
	movlw	0x44	; 
	call	act
	movlw	0x55	; 
	call	act
	movlw	0x66	; 
	call	act
	movlw	0x0C	; 
	call	act
	movlw	0x0C	; 
	call	act
	movlw	0xFF	; 
	call	act
	call	iicp	; i2c stop
	call	pause
;***************************************************
	call	pause
;***************************************************
homa	goto	homa
;***************************************************
;***************************************************
;***************************************************
act	movwf transo	; iic data transmission 
	movlw 0x08
	movwf count3
vbit	bcf	sclk
	call	haltb
	btfsc transo,7	
	bsf	sdta
	btfss transo,7
	bcf	sdta
	call	haltb
	bsf	sclk
	call	haltb
	bcf	sclk
	call	haltb
	rlf	transo,F
	decfsz	count3,F
	goto	vbit
	call	ackp
	retlw	0x00
;***************************************************
iicp	bcf	sdta	; stop condition module
	call	haltb
	bsf	sclk
	call	haltb
	bsf	sdta	; stop command
	call	haltb
	bcf	sclk
	call	haltb
	retlw	0x00
;***************************************************	
iict	bsf	sdta	; start condition module 
	bsf	sclk
	call	haltb
	bcf	sdta	; start command
	call	haltb
	bcf	sclk
	call	haltb
	retlw	0x00
;***************************************************
ackp	call	ser_in
	bsf	sclk	; one clock step for acknowledge (not read)
	call	haltb
	bcf	sclk
	call	ser_out
	retlw	0x00
	
;************************************************************************
;	Subrutine de intarziere				 				*
;************************************************************************
;________________________________________________________________________
haltb	movlw	0x7A	  
	movwf	count2
g2	nop
	decfsz	count2,F	
	goto	g2	
 	return
;________________________________________________________________________
pause	movlw	0x04 ;	cca. 1s
hopa	movwf	count3
d3	movlw	0xF9
	movwf	count1
d1	movlw	0xFA	  
	movwf	count2
d2	nop
	decfsz	count2,F	
	goto	d2		
	decfsz	count1,F	
	goto	d1		
	decfsz	count3,F    
	goto	d3          
	retlw	0x00
;************************************************************************
ser_in
	bsf	STATUS,RP0	; Bank 1
	movlw	0x01	; input
	movwf	TRISB
	bcf	STATUS,RP0	; Bank 0
	return
;************************************************************************
ser_out
	bsf	STATUS,RP0	; Bank 1
	movlw	0x00	; output
	movwf	TRISB
	bcf	STATUS,RP0	; Bank 0
	return
;------------------------------------------------------------
	end
;============================================================
